#!/bin/sh
#----------------------------------------------------------------------
#
# ebaywap.sh
#
# V1.4g
#
# Ebay Artikelinfos ueber das WAP-Portal anzeigen
#
# Quelle: http://wap.ebay.de
#
# Flexmenu Plugin und TuXWetter Plugin mssen installiert sein
#
# Aufruf bers Flexmenu:
#
# Dreambox:
#
# ACTION=Ebay WAP Suche,( /var/script/ebaywap.sh makemainmenu ; if [ -f /tmp/ebaywap_main.inc ] ; then /var/bin/shellexec /tmp/ebaywap_main.inc ; rm /tmp/ebaywap* ; else msgbox popup='Fehler bei der Ermittlung der Daten' timeout=5 ;fi )
#
# Dbox:
#
# ACTION=Ebay WAP Suche,( /var/plugins/ebaywap.sh makemainmenu ; if [ -f /tmp/ebaywap_main.inc ] ; then /var/plugins/shellexec /tmp/ebaywap_main.inc ; rm /tmp/ebaywap* ; else msgbox popup='Fehler bei der Ermittlung der Daten' timeout=5 ;fi )
#
#
#-------------------------------------------------------------------------
# V1.0a Fehler behoben falls noch keine Suchliste/Artikelliste existiert, LD_LIBRARY Path gesetzt
#
# V1.1 Fehler bereinigt, Vorwarnzeit, Suche editieren, Letzes Suchergebnis speichern
#
# V1.1a Fehler bereinigt
#
# V1.2 falsche Artikelnummern abfangen, keine Vorwarnzeit Eingabe bei abgelaufenen Auktionen
#      Konfig-Pfade und Variablennamen angepasst
#      NEU: Flexmenu Aufbau und Suche nach Mitgliedsnamen
#
# V1.3 Euro-Zeichen gefixt        s/&#8364;/Euro/g
#       Non-breaking space gefixt  s/&#160;/ /g
#       +- Zeichen                 s/&#177;/ /g
#       Timeout auf 30 gesetzt
#       Artikelinfo Ausgabeformat geaendert,
#       Alle Verkaeufer-Auktionen ermitteln und anzeigen
#       Fehler bei * oder _ Zeichen im Mitgliedsnamen gefixt, danke rich :-)
#       Fortschrittsanzeige beim Download von mehr als 6 Artikeln
#
# V1.3a Fortschrittsanzeige: Fehler bei der Berechnung der Seitenanzahl gefixt
#
# V1.4a Boxtyp Abfrage dreambox / dbox in Abhaengigkeit vom Boxtyp div. Variable setzen
#       crontab/dreambox bzw. timer/dbox Aufruf ueber eigene function
#       Alle Bieter-Auktionen ermitteln und anzeigen
#       Bei der Fortschrittsanzeige den msgbox Anzeigeparameter refresh=0 gesetzt um Flexmenu auszublenden
#       Das  < > Zeichen gefixt
#       Uhrzeit Funktion geloescht wird nicht benoetigt
#       Fuer 'Mein Ebay' ein eigenes Menu erstellt und neue Abfrage 'Mein Ebay aktuelle Gebotsuebersicht' hinzugefuegt
#       Menutext 'Letztes Suchergebnis anzeigen' in 'Letzte Mitglieder Suche anzeigen' geaendert
#       Variable 'endzeit_sec' in 'endzeit_utc_sec' geaendert
#
#
# V1.4b Boxtype und  Pfad zur crontab fuer Dreambox 7020 angepasst
#       check Fehler busybox 1.0.1 wieder eingebaut wegen Dreambox 7020
#       ansonsten keine Aenderungen fuer Dreambox 7000/500 und Dbox gemacht
#
# V1.4c Fehler in der Berechnung der Vorwarnzeit gefixt.
#       Wird Artikelnummer geloescht wird, falls vorhanden,
#       auch der crontab Eintrag fuer die Vorwarnzeit entfernt. ( danke bexbier )
#
# V1.4d div. Aenderungen wegen Aenderungen im Seitenaufbau
#
# V1.4e Fehler in der Berechnung der Vorwarnzeit gefixt. Danke rich :-)
#
#       Da auf dem WAP-Portal nur noch 4 und nicht mehr 6 Artikel pro Seite dargestellt
#       werden, die Berechnung der Seitenanzahl korrigiert
#
# V1.4f Fehler bei der freien Textsuche bereinigt
#
# V1.4g Zustzliche Soundausgabe fr die Dbox bei Erinnerungstimern eingebaut (DrStoned)
#
# Autor: barabas
#        Adaption auf DBox: rich
#        bei der Umsetzung auf die D-Box Crontab in Erinnerungstimer umgebaut: rich
#        Zustzliche Soundausgabe fr die Dbox bei Erinnerungstimern eingebaut: DrStoned 
#---------------------------------------------------------------------------------------
#set -x

#-------------------Boxtyp ermitteln Dreambox/DBox----------------------

boxtype=`uname -n`
[ $boxtype != "dreambox" -a $boxtype != "dm7020" ] && boxtype="dbox"

#-----------------------------------------------------------------------
# Artikelliste, Suchliste Pfad falls gewuenscht hier ndern
#-----------------------------------------------------------------------
artikelliste=/var/tuxbox/config/ebaywap_artikelliste.txt
suchtextliste=/var/tuxbox/config/ebaywap_suchtextliste.txt
memberliste=/var/tuxbox/config/ebaywap_memberliste.txt
meine_ebayliste=/var/tuxbox/config/ebaywap_meinebayliste.inc


if [ $boxtype = "dbox" ] ; then
		# Wenn eine Festplatte in der Dbox2 eingebaut ist und das Verzeichnis
		# /hdd/tuxbox/config/ angelegt wurde, werden die Suchlisten dort gespeichert

		if [ -e /hdd/tuxbox/config/ ] ; then
			letztesuchliste=/hdd/tuxbox/config/lastsearchliste_ebaywap.inc
    	letzte_membersuche=/hdd/tuxbox/config/lastmembersearch_ebaywap.inc
    else
			letztesuchliste=/tmp/lastsearchliste_ebaywap.inc
    	letzte_membersuche=/tmp/lastmembersearch_ebaywap.inc
    fi;
    # Pfad zur shellexec, tuxwetter und msgbox
    shellexec="/var/plugins/shellexec"
    if [ -e /bin/msgbox ] ; then msgbox="/bin/msgbox"
		  else msgbox="/var/bin/msgbox"
		fi;
    input="/var/bin/input"
    tuxwetter="/var/plugins/tuxwet/tuxwetter"

else

    letztesuchliste=/var/tuxbox/config/ebaywap_lastsearchliste.inc
    letzte_membersuche=/var/tuxbox/config/ebaywap_lastmembersearch.inc

    #  LD_LIBRARY_PATH setzen wegen libcurl Problem auf der Dreambox
    export LD_LIBRARY_PATH=/tmp:/var/lib:/lib:/var/bin/tuxwet

    # Pfad zur shellexec, tuxwetter und msgbox
    shellexec="/var/bin/shellexec"
    msgbox="/var/bin/msgbox"
    input="/var/bin/input"
    tuxwetter="/var/bin/tuxwet/tuxwetter"

    # Pfad zur Crontab
    [ $boxtype = "dreambox" ] && crontab="/var/etc/crontab"
    [ $boxtype = "dm7020" ] && crontab="/var/bin/crontab"

fi

# check echo Fehler busybox
[ `echo "\r" | grep -c "\r"` -gt 0 ] && alias echo="echo -e"

# Steuerzeichen
TAB=`echo -e "\t"`
CRLF=`echo -e "\r"`
CR=`echo -e "\n"`

# Menutitel
menutitel="Ebay WAP Suche V1.4g $boxtype"

# globale Variablen definieren
vzeit=""
vorwarnzeit=""
endzeit_utc_sec=""
artikelnr=""
action=""
timer_no=""
timer_al=""

#---------------------------------------------------------------------
# Flexmenu, Tuxwetter Include Files
#---------------------------------------------------------------------
menumain="/tmp/ebaywap_main.inc"

#---------------------------------------------------------------------
# URLs
#---------------------------------------------------------------------

base_url="http://wap.ebay.de"
search_url="http://wap.ebay.de/search/search_ext_res.asp?emvef=%BF&emvquer=BARABAS_EBAYWAP&emvstype=0&emvsidesc=0&emvsi=1&emvcat=0&emvsid=H20r747X77856162q1"
member_url="http://wap.ebay.de/search/search_ext_res.asp?emvef=%BF&emvquer=BARABAS_EBAYWAP&emvstype=2&emvsid=2OF8Oh3Ntgkoe7QHyd"
versand_url="http://wap.ebay.de/bid/viewitem_ext.asp?iTab=1&emv_id=_ARTIKELNUMMER_&emvsid=_SID_"
beschreibung_url="http://wap.ebay.de/bid/viewitemdesc.asp?emv_id=_ARTIKELNUMMER_&emvsid=_SID_"
foto_url="http://wap.ebay.de/bid/slideshow.asp?emv_id=_ARTIKELNUMMER_&emvsid=_SID_"
info_url="http://wap.ebay.de/bid/viewitem.asp?emv_id=_ARTIKELNUMMER_"

#---------------------------------------------------------------------
# Timeout und Kill Funktion von rich aus dem Keywelt Board
# danke rich :-)
#---------------------------------------------------------------------
kill_funktion() {
	kill $$
	msgbox size=32 timeout=7 refresh=2 title="$menutitel" popup="~cTimeout:  Der Server ist nicht erreichbar !"
	exit 1
}
timeout() {
	sleep 30 && kill_funktion &
}


#------------------- Hauptmenu zusammenbauen ------------------

makemainmenu () {

     [ -s $meine_ebayliste ] && meinebay_anzahlartikel=`grep -c 'COMMENT=' $meine_ebayliste`
     echo "
      FONT=/share/fonts/micron_bold.ttf
      FONTSIZE=18
      LINESPP=11
      MENU=$menutitel
       MENU=Freie Text Suche
          ACTION=&Suchbegriff eingeben u. suchen, $0 neuesuche
          ACTION=&Suchbegriff ausw~ahlen, $0 speichersuche
          ACTION=&Suchbegriff ~andern, $0 editsuche
          ACTION=&Suchbegriff l~oschen, $0 loeschsuche
        DEPENDON=&Letztes Suchergebnis anzeigen, $0 letztesuche $letztesuchliste,$letztesuchliste
       ENDMENU
       MENU=Suche nach Artikelnummer
         ACTION=&Artikelnummer eingeben u. suchen, $0 neueartikelnr
         ACTION=&Artikelnummer ausw~ahlen, $0 leseartikelnr
         ACTION=&Artikelnummer l~oschen, $0 loeschartikelnr
       DEPENDON=&Alle Artikelnummern ausw~ahlen, $0 alle_artikelnranzeigen,$artikelliste
       ENDMENU
       MENU=Suche nach Mitgliedername
         ACTION=&Mitgliedername eingeben u. suchen, $0 membersuche
         ACTION=&Mitgliedername ausw~ahlen, $0 speichermembersuche
         ACTION=&Mitgliedername ~andern, $0 editmember
         ACTION=&Mitgliedername l~oschen, $0 loeschmember
         DEPENDON=&Suche in -Mein Ebay- speichern, cp $letzte_membersuche $meine_ebayliste,$letzte_membersuche
         COMMENT=*
         DEPENDON=&Letzte Mitglieder Suche anzeigen, $0 letztesuche $letzte_membersuche,$letzte_membersuche
       ENDMENU
       MENUDON=Mein Ebay,$meine_ebayliste
         ACTION=& Mein Ebay Artikelliste anzeigen, $shellexec $meine_ebayliste
         ACTION=& Mein Ebay akt. Gebots~ubersicht, $0 meine_ebayliste_gebote
         COMMENT=Es befinden sich $meinebay_anzahlartikel Artikel in der Liste
       ENDMENU
      ENDMENU" >$menumain

  }

#--------- Mitgliedsname, speichern und suchen ----------

membersuche () {

         set -x
          # membersuche wird aus artikelinfo mit Angabe des Verkaeufernamens aufgerufen
          # dann Inputbox nicht anzeigen
          if [ $# -eq 0 ] ; then

            suche=`$input l='@@@@@@@@@@@@@@@@@@@@@@' d="_" t='Mitgliedername eingeben' k=1`
            if [ `echo "$suche" | grep -c '[0-9a-zA-Z]'` -eq 0 ] ; then return 0 ; fi

          else
             suche="$1"
          fi

          # nachfolgende Leerzeichen loeschen
          titelname="$suche"
          suche=`echo "$suche" | sed 's/ *$//'`

          # wenn jetzt noch Leerzeichen oder bestimmte Sonderzeichen wie [ @, &, ', < , >, ]
          # enthalten sind -> Fehlermeldung ausgeben
          if [ `echo "$suche" |  grep -c "[@,&,',<,>, ]"` -gt 0 ] ; then
           $msgbox title="Achtung!" msg="~nMitgliedsname -$suche- fehlerhaft!~n~nSonderzeichen:  @, &, ', < , > und Leerzeichen sind nicht erlaubt!"
           return 1
          fi

          # Suchbegriff abspeichern falls noch nicht gespeichert
          [ ! -s $memberliste ] && touch $memberliste
          [ `grep -c "^${suche}$" $memberliste ` -eq 0 ] && echo "$suche" >>$memberliste

          # falls Umlaute verwendet wurden werden diese in der inputbox autom. umgewandelt
          # deshalb hier wieder tauschen
          suche=`echo $suche | sed 's/~a//g;s/~o//g;s/~u//g;s/~A//g;s/~O//g;s/~U//g;s/~z//g'`

          # altes Suchergebnis loeschen
          if [ -s /tmp/ebaywap_mansearchresult.txt ] ; then rm /tmp/ebaywap_mansearchresult.txt ; fi

          # Artikelliste erstellen ; Sucheergebnis speichern und aufrufen
          artikelauswahl "$suche" false "$member_url" member
          if [ $? -eq 0 ] ; then

            flexkonf kopf "Artikelliste: $titelname" ; flexkonf main member ; flexkonf ende

            if [ -s /tmp/ebaywap_mansearchresult.inc ] ; then
              cp /tmp/ebaywap_mansearchresult.inc $letzte_membersuche
              $shellexec /tmp/ebaywap_mansearchresult.inc
            fi

          fi
   }

#-------------- Gespeicherten Mitgliedsname auswaehlen ---------

speichermembersuche () {

          if [ ! -s $memberliste ] ; then $msgbox title="Achtung!" msg="Keine Mitglieder-Liste vorhanden~noder Mitglieder-Liste leer" timeout=5 ; return 0 ; fi

          # Abfrage Member Auswahl
          button=""

          while read line ; do
             button="$button,$line"
          done <$memberliste

          suche=`$msgbox title="$menutitel" size=24 order=2 echo=1 select="$button" msg="Mitglied ausw~ahlen:"`

          # -z funktioniert hier nicht, nochmal testen.....
          if [ `echo "$suche" | grep -c '[0-9a-zA-Z]'` -eq 0 ] ; then return 0 ; fi

          # alle Leerzeichen im Suchbegeiff durch + ersetzen
          titelname="$suche"
          suche=`echo $suche | sed 's/ /+/g'`

          # alte temp. Suchabfrage loeschen
          if [ -s /tmp/ebaywap_mansearchresult.txt ] ; then rm /tmp/ebaywap_mansearchresult.txt ; fi

          # Artikelliste erstellen ; Sucheergebnis speichern und aufrufen
          artikelauswahl "$suche" false "$member_url" member
          if [ $? -eq 0 ] ; then

            flexkonf kopf "Artikelliste: $titelname" ; flexkonf main member ; flexkonf ende

            if [ -s /tmp/ebaywap_mansearchresult.inc ] ; then
              cp /tmp/ebaywap_mansearchresult.inc $letzte_membersuche
              $shellexec /tmp/ebaywap_mansearchresult.inc
            fi

          fi
    }

#-------------- Gespeicherten Mitgliedsname loeschen ---------

loeschmember () {

          if [ ! -s $memberliste ] ; then $msgbox title="Achtung!" msg="Keine Mitglieder-Liste vorhanden~noder Mitglieder-Liste leer." timeout=5 ; return 0 ; fi

          # Abfrage Member Auswahl
          button=""
          while read line ; do
             button="$button,$line"
          done <$memberliste

          suche=`$msgbox title="$menutitel" size=24 order=2 echo=1 select="$button" msg="Zu lschenden Mitgliedsname ausw~ahlen:" | sed -e 's/*/\\\*/g'`

          # Suchbegriff aus Liste loeschen, wenn Liste leer ->Liste loeschen
          sed -i "/^$suche$/d" $memberliste
          [ ! -s $memberliste ] && rm $memberliste
   }

#-------------- Gespeicherten Mitgliedsname editieren ---------

editmember () {

          if [ ! -s $memberliste ] ; then $msgbox title="Achtung!" msg="Keine Mitglieder-Liste vorhanden~noder Mitglieder-Liste leer." timeout=5 ; return 0 ; fi

          # Abfrage Member Auswahl
          button=""
          while read line ; do
             button="$button,$line"
          done <$memberliste

          altesuche=`$msgbox title="$menutitel" size=24 order=2 echo=1 select="$button" msg="Zu editierenden Mitgliedsname ausw~ahlen:"`

          if [ `echo "$altesuche" | grep -c '[0-9a-zA-Z]'` -eq 0 ] ; then return 0 ; fi

          neuesuche=`$input l='@@@@@@@@@@@@@@@@@@@@' t='Mitgliedsname editieren' k=1 d="$altesuche"`

          if [ `echo "$neuesuche" | grep -c '[0-9a-zA-Z]'` -eq 0 ] ; then return 0 ; fi

          # nachfolgende Leerzeichen loeschen
          neuesuche=`echo $neuesuche | sed 's/ *$//'`

          # falls Umlaute verwendet wurden werden diese in der inputbox autom. umgewandelt
          # deshalb hier wieder tauschen
          neuesuche=`echo $neuesuche | sed 's/~a//g;s/~o//g;s/~u//g;s/~A//g;s/~O//g;s/~U//g;s/~z//g'`

          # alten Mitgliedsname aus Liste loeschen
          sed -i "/^$altesuche$/d" $memberliste

          # neuen Mitgliedsname abspeichern
          echo "$neuesuche" >>$memberliste
   }

#-------------- Mein Ebay Liste Gebotsueberischt ---------------------

meine_ebayliste_gebote () {

       # altes Suchergebnis loeschen
       if [ -s /tmp/ebaywap_mansearchresult.txt ] ; then rm /tmp/ebaywap_mansearchresult.txt ; fi

       for line in `sed -e '/COMMENT=\*/!d' -e 's/COMMENT=\*//' $meine_ebayliste`
       do
          suche="$suche,$line"
       done

       # Suchbegriffe Klammern
       suche="($suche)"

       # Artikelliste erstellen ; Sucheergebnis speichern und aufrufen
       artikelauswahl "$suche" false "$search_url" text
       if [ $? -eq 0 ] ; then

          flexkonf kopf "Artikelliste -Mein Ebay-" ; flexkonf main text ; flexkonf ende

          if [ -s /tmp/ebaywap_mansearchresult.inc ] ; then
            cp /tmp/ebaywap_mansearchresult.inc $letztesuchliste
            $shellexec /tmp/ebaywap_mansearchresult.inc
          fi

       fi


  }
#--------- Neuen Suchbegriff eingeben, speichern und suchen ----------

neuesuche () {


          suche=`$input l='@@@@@@@@@@@@@@@@@@@@' d="_" t='Suchbegriff eingeben' k=1`

          if [ `echo "$suche" | grep -c '[0-9a-zA-Z]'` -eq 0 ] ; then return 0 ; fi

          # nachfolgende Leerzeichen loeschen
          suche=`echo $suche | sed 's/ *$//'`

          # Suchbegriff abspeichern falls noch nicht gespeichert
          [ ! -s $suchtextliste ] && touch $suchtextliste
          [ `grep -c "^${suche}$" $suchtextliste` -eq 0 ] && echo "$suche" >>$suchtextliste

          # falls Umlaute verwendet wurden werden diese in der inputbox autom. umgewandelt
          # deshalb hier wieder tauschen
          suche=`echo $suche | sed 's/~a//g;s/~o//g;s/~u//g;s/~A//g;s/~O//g;s/~U//g;s/~z//g'`

          # Leerzeichen im Suchbegeiff durch + ersetzen
          titelname="$suche"
          suche=`echo $suche | sed 's/ /+/g'`

          # altes Suchergebnis loeschen
          if [ -s /tmp/ebaywap_mansearchresult.txt ] ; then rm /tmp/ebaywap_mansearchresult.txt ; fi

         # Artikelliste erstellen ; Sucheergebnis speichern und aufrufen
          artikelauswahl "$suche" false "$search_url" text
          if [ $? -eq 0 ] ; then

            flexkonf kopf "Artikelliste: $titelname" ; flexkonf main text ; flexkonf ende

            if [ -s /tmp/ebaywap_mansearchresult.inc ] ; then
              cp /tmp/ebaywap_mansearchresult.inc $letztesuchliste
              $shellexec /tmp/ebaywap_mansearchresult.inc
            fi

          fi
   }

#-------------- Gespeicherten Suchebegriff loeschen ---------

loeschsuche () {

          if [ ! -s $suchtextliste ] ; then $msgbox title="Achtung!" msg="Keine Suchliste vorhanden oder Suchliste leer" timeout=5 ; return 0 ; fi

          # Abfrage Suchbegriff Auswahl
          button=""
          while read line ; do
             button="$button,$line"
          done <$suchtextliste

          suche=`$msgbox title="$menutitel" size=24 order=2 echo=1 select="$button" msg="Zu lschenden Begriff ausw~ahlen:"`

          # Suchbegriff aus Liste loeschen, wenn Liste dann leer ->Liste loeschen
          sed -i "/^$suche$/d" $suchtextliste
          [ ! -s $suchtextliste ] && rm $suchtextliste
   }

#-------------- Gespeicherten Suchebegriff editieren ---------

editsuche () {

          if [ ! -s $suchtextliste ] ; then $msgbox title="Achtung!" msg="Keine Suchliste vorhanden oder Suchliste leer" timeout=5 ; return 0 ; fi

          # Abfrage Suchbegriff Auswahl
          button=""
          while read line ; do
             button="$button,$line"
          done <$suchtextliste

          altesuche=`$msgbox title="$menutitel" size=24 order=2 echo=1 select="$button" msg="Zu editierenden Begriff ausw~ahlen:"`

          if [ `echo "$altesuche" | grep -c '[0-9a-zA-Z]'` -eq 0 ] ; then return 0 ; fi

          neuesuche=`$input l='@@@@@@@@@@@@@@@@@@@@' t='Suchbegriff editieren' k=1 d="$altesuche"`

          if [ `echo "$neuesuche" | grep -c '[0-9a-zA-Z]'` -eq 0 ] ; then return 0 ; fi

          # nachfolgende Leerzeichen loeschen
          neuesuche=`echo $neuesuche | sed 's/ *$//'`

          # falls Umlaute verwendet wurden werden diese in der inputbox autom. umgewandelt
          # deshalb hier wieder tauschen
          neuesuche=`echo $neuesuche | sed 's/~a//g;s/~o//g;s/~u//g;s/~A//g;s/~O//g;s/~U//g;s/~z//g'`

          # alten Suchbegriff aus Liste loeschen
          sed -i "/^$altesuche$/d" $suchtextliste

          # neuen Suchbegriff abspeichern
          echo "$neuesuche" >>$suchtextliste
   }

#-------------- Gespeicherten Suchebegriff auswaehlen ---------

speichersuche () {

          if [ ! -s $suchtextliste ] ; then $msgbox title="Achtung!" msg="Keine Suchliste vorhanden oder Suchliste leer" timeout=5 ; return 0 ; fi

          # Abfrage Suchbegriff Auswahl
          button=""

          while read line ; do
             button="$button,$line"
          done <$suchtextliste

          suche=`$msgbox title="$menutitel" size=24 order=2 echo=1 select="$button" msg="Suchbegriff ausw~ahlen:"`

          # -z funktioniert hier nicht, nochmal testen.....
          if [ `echo "$suche" | grep -c '[0-9a-zA-Z]'` -eq 0 ] ; then return 0 ; fi

          # alle Leerzeichen im Suchbegeiff durch + ersetzen
          titelname="$suche"
          suche=`echo $suche | sed 's/ /+/g'`

          # alte temp. Suchabfrage loeschen
          if [ -s /tmp/ebaywap_mansearchresult.txt ] ; then rm /tmp/ebaywap_mansearchresult.txt ; fi

         # Artikelliste erstellen ; Sucheergebnis speichern und aufrufen
          artikelauswahl "$suche" false "$search_url" text
          if [ $? -eq 0 ] ; then

            flexkonf kopf "Artikelliste: $titelname" ; flexkonf main text ; flexkonf ende

            if [ -s /tmp/ebaywap_mansearchresult.inc ] ; then
              cp /tmp/ebaywap_mansearchresult.inc $letztesuchliste
              $shellexec /tmp/ebaywap_mansearchresult.inc
            fi

          fi

    }

#--------- letztes Suchergebnis wieder anzeigen ----------

letztesuche () {

          # gespeicherte Suchliste aus /var/tuxbox/config uebergeben
          liste="$1"

          if [ -s $liste ] ; then

           $shellexec $liste

          fi

  }

#------------------- Neue Artikelnummer eingeben, speichern und anzeigen ----------------------------

neueartikelnr () {

          artikelnr=`$input l='############' t='Neue Artikelnummer eingeben' k=0`

          if [ `echo "$artikelnr" | grep -c '[0-9]'` -eq 0 ] ; then return 0 ; fi

          # Artikelnummer abspeichern falls noch nicht gespeichert
          [ ! -s $artikelliste ] && touch $artikelliste
          [ `grep -c "^${artikelnr}" $artikelliste` -eq 0 ] && echo "$artikelnr" >>$artikelliste

          artikelinfo `echo $info_url | sed "s/_ARTIKELNUMMER_/$artikelnr/"` "zur~uck"

    }

#-------------- Gespeicherte Artikelnummer loeschen ---------

loeschartikelnr () {

          if [ ! -s $artikelliste ] ; then $msgbox title="$menutitel" msg="Keine Artikelliste vorhanden oder Artikelliste leer" timeout=5 ; return 0 ; fi

          # Abfrage Artikelnummer Auswahl, nach dem _ steht ggfs. die Vorwarnzeit diese entfernen
          button=""
          while read line ; do
             button="$button,${line%% *}"
          done <$artikelliste

          artikelnr=`$msgbox title="$menutitel" size=24 order=3 echo=1 select="$button" msg="Zu lschende Artikelnummer ausw~ahlen:"`

          if [ `echo "$artikelnr" | grep -c '[0-9]'` -eq 0 ] ; then return 0 ; fi

          # Crontab ( Vorwarnungstimer ) Eintrag lschen
          [ -s $crontab ] && sed -i "/$artikelnr/d" $crontab

          # Artikelnummer aus Liste loeschen, wenn Liste dann leer ->Liste loeschen
          sed -i "/^$artikelnr/d" $artikelliste
          [ ! -s $artikelliste ] && rm $artikelliste

   }

#-------------- Gespeicherte Artikelnummer auswaehlen und anzeigen ---------

leseartikelnr () {

          if [ ! -s $artikelliste ] ; then $msgbox title="$menutitel" msg="Keine Artikelliste vorhanden oder Artikelliste leer" timeout=5 ; return 0 ; fi

          # Abfrage Artikelnummer Auswahl, nach dem _ steht ggfs. die Vorwarnzeit diese entfernen
          button=""
          while read line  ; do
             button="$button,${line%% *}"
          done <$artikelliste

          artikelnr=`$msgbox title="$menutitel" size=24 order=3 echo=1 select="$button" msg="Artikelnummer ausw~ahlen:"`

          if [ `echo "$artikelnr" | grep -c '[0-9]'` -eq 0 ] ; then return 0 ; fi

          # Vorwarnzeit ermitteln, set liefert $1 $2 etc.
          # fuer 110075909983 15  -> $1=110075909983 $2=15
          set `grep $artikelnr $artikelliste`
          vzeit=$2

          artikelinfo `echo $info_url  | sed "s/_ARTIKELNUMMER_/$artikelnr/"` "zur~uck"

   }

#------------------- Alle Artikelnr aus Artikelliste anzeigen ------------------

alle_artikelnranzeigen () {

       if [ -s $artikelliste ] ; then

            while read line  ; do

               # Artikelnummer und Vorwarnzeit ermitteln
               set `echo $line` ;  artikelnr=$1 ; vzeit=$2
               # Info aufrufen
               artikelinfo `echo $info_url | sed "s/_ARTIKELNUMMER_/$artikelnr/"` "weiter" || break

            done <$artikelliste

       else

           $msgbox title="$menutitel" size=24 msg="Artikelliste: ~B$artikelliste~S nicht gefunden! ~nBitte neu anlegen, oder Artikelnummer aus manueller Suche ~ubernehmen."

       fi

  }

#------------------- Artikelauswahl erzeugen  ----------------------------
# Aufruf: artikelauswahl <suche:suchstring|member> <runonce:true|false> <url:search_url|member_url> <suchtyp:text|member>

artikelauswahl () {

          # Suchbegriff
          suche="$1"

          # Variable fuer einmalige Abfrage ob Ausgabe erfolgen soll
          # macht Sinn bei zu vielen Suchergebnissen :-)
          runonce="$2"

          # URL Typ
          url="$3"

          # Typ der Suchabfrage, Text- oder Mitgliedersuche
          suchtyp="$4"

          if [ $suchtyp = "member" ] ; then
            # Bei Mitgliedersuche 2 Moeglichkeiten. Mitglied hat keine Auktionen oder nicht gefunden
            suchtext='Von diesem Verk&#228;ufer werden zur Zeit keine Artikel angeboten.'
            suchtext2='F&#252;r die eingegebene Suche konnten keine Ergebnisse gefunden werden.'
          else
            # hier zweimal das gleiche da grep bei fehlendem Suchstring immer eine 1 zurueck liefert.....
            suchtext='Es wurden keine Artikel gefunden'
            suchtext2=$suchtext
          fi
          # aktuelle SuchUrl zusammensetzen dazu den Dummyeintrag durch den Suchstring ersetzen
          actsearch_url=`echo $url | sed "s@BARABAS_EBAYWAP@$suche@"`

          loop="true"
          # Schleife solange durchlaufen bis alle Seiten eingelesen sind
          while $loop ; do

                # Ebay WAP Portal Suche starten
                timeout
                wget -q -O /tmp/ebaywap_mansearchresult.htm "$actsearch_url"
                kill $!

                if [ -s /tmp/ebaywap_mansearchresult.htm ] ; then

                      if [ `grep -ce "$suchtext" -ce "$suchtext2" /tmp/ebaywap_mansearchresult.htm` -gt 0 ] ; then

                        # ermitteln ob es sich um eine abgelaufene Artikelnummer aus der Artikelliste handelt
                        # ja -> loeschen anbieten
                        if [ `grep -c "^$suche" $artikelliste` -eq 1 ] ; then

                           $msgbox title="$menutitel" size=26 select="Ja,Nein" msg="Fr Artikelnummer: ~Y$suche~S wurden keine Informationen gefunden.~nArtikelnummer aus Liste l~oschen?"
                           case $? in
                               1) sed -i "/^$suche/d" $artikelliste
                                  ;;
                               *) ;;
                           esac

                        else

                           $msgbox title="$menutitel" size=28 msg="~nF~ur~n~s~n~Y$suche~S~n~s~nwurden keine Artikel gefunden.~n" timeout=8

                        fi

                        # Funktion verlassen
                        return 1

                      fi

                      sed '# Workarround Nummer der Artikel in der Liste entfernen
                           s:<br />[0-9]*\&#160;<a href=:<br />\&#160;<a href=:g
                           # Seitenangabe entfernen
                           s:(S\. .*/.*)::g
                           # Workarround fuer fehlende Gebotseintraege, fehlende Eintraege durch 0 Gebote ersetzen
                           s:\&#160;\&#160;\&#160;\&#160;:\&#160;\&#160;0\&#160;\&#160;:g' /tmp/ebaywap_mansearchresult.htm |\

                      sed "# komplette Zeile bis zu Ergebnisse loeschen
                           s/^.*Ergebnisse:/Ergebnisse:/
                           # alle href Tags durch Zeilenumbruch ersetzen
                           s@<a href=\"@\n@g

                           # alle Tags durch Marker ersetzen und uebrigen Muell loeschen
                           s/<[^>]*>/@/g
                           s/amp;//g
                           s/\&#160;/@/g
                           s/\">/@/g
                           s/----*@//g
                           s/*//g

                           # Umlaute, Sonderzeichen und Komma wandeln
                           s/&#252;/~u/g
                           s/&#246;/~o/g
                           s/&#252;/~u/g
                           s/&#228;/~a/g
                           s/&#223;/~z/g
                           s/&#196;/~A/g
                           s/&#214;/~O/g
                           s/&#220;/~U/g
                           s/&#8364;/Euro/g
                           s/&#177;/ /g
                           s/&#167;//g
                           s/&#62;/>/g
                           s/&#60;/</g

                           # das Zeichen=  loeschen
                           s/&#176;//g

                             s/,/./g" |\

                           # doppelte Marker und nicht benoetigte Zeilen loeschen
                      sed 's/@*/@/g
                           /@Mich-Seite@/d
                           /@Bewertungen@/d
                           /@Neue Suche@/d
                           /@Startseite@/d
                           /@Impressum@/d
                           /@Suche ver~andern@/d' >>/tmp/ebaywap_mansearchresult.txt

                            # Ausgabedatei fuer Text und Artikelsuche sieht jetzt so aus, falls weitere Ausgabeseiten vorhanden sind steht in
                            # der letzen Zeile '@weiter@'
                            # @Ergebnisse: dreambox 7000@42 Artikel gefunden:@1@
                            # @http://wap.ebay.de/bid/viewitem.asp?emv_id=180070582758&emvsid=JFKra5JRauBgPimpg9@***DREAMBOX Reparatur***7000/5620/5000*** Dortmund/NRW@29,00 EUR@0@05.01.2007 21:43@2@
                            # @http://wap.ebay.de/bid/viewitem.asp?emv_id=270074622391&emvsid=JFKra5JRauBgPimpg9@Dreambox Tastatur , Keyboard , f~ur DM 500 , 7000 , 7020@16,60 EUR@4@06.01.2007 12:33@3@
                            # @http://wap.ebay.de/bid/viewitem.asp?emv_id=200063858188&emvsid=JFKra5JRauBgPimpg9@DREAMBOX DM 7000-S DVB-S 120 GB HDD Recorder@301,00 EUR@29@06.01.2007 12:40@4@
                            # @http://wap.ebay.de/bid/viewitem.asp?emv_id=270073269543&emvsid=JFKra5JRauBgPimpg9@DREAMBOX FERNBEDIENUNG F~UR DM 7000, DM 7020, DM 7025 S@33,40 EUR@06.01.2007 16:02@5@
                            # @http://wap.ebay.de/bid/viewitem.asp?emv_id=140068570325&emvsid=JFKra5JRauBgPimpg9@Dreambox DM 7000 S mit 120 GB Festplatte@231,00 EUR@15@06.01.2007 19:10@6@
                            # @http://wap.ebay.de/bid/viewitem.asp?emv_id=330069289270&emvsid=JFKra5JRauBgPimpg9@Dreambox DM 7000-S 120GB Festplattenreceiver@261,00 EUR@18@06.01.2007 20:57@(S. 1/7)@
                            # @http://wap.ebay.de/search/search_ext_res.asp?emvsi=2&emvquer=dreambox+7000&emvsidesc=0&emvstype=0&emvcat=0&emvexp=0&emvstate=&emvauctype=&emvmin=&emvmax=&emvdist=&emvzip=&emvsid=JFKra5JRauBgPimpg9@weiter@----------------------------@

                            # Ausgabedatei fuer Mitglieder Artikel
                            # @Ergebnisse: hmepowerseller@
                            # @http://wap.ebay.de/bid/viewitem.asp?emv_Id=200059487770&emvsid=2OF8Oh3Ntgkoe7QHyd@550 Watt ATX Fl~uster-Netzteil Stability 120mm # 41002@
                            # @http://wap.ebay.de/bid/viewitem.asp?emv_Id=200059523064&emvsid=2OF8Oh3Ntgkoe7QHyd@Pioneer DVR-K06 Slim 8x DVD f~ur Notebooks  #17829@
                            # @http://wap.ebay.de/bid/viewitem.asp?emv_Id=200065360788&emvsid=2OF8Oh3Ntgkoe7QHyd@1 GB DDR2-533 RAM von Aeneon / Infineon #46632@
                            # @http://wap.ebay.de/bid/viewitem.asp?emv_Id=200065361734&emvsid=2OF8Oh3Ntgkoe7QHyd@1 GB DDR2-677 RAM von Aeneon / Infineon #46635@
                            # @http://wap.ebay.de/bid/viewitem.asp?emv_Id=200065431615&emvsid=2OF8Oh3Ntgkoe7QHyd@Ext. LG 16 fach Multibrenner H 12 im Alugeh~ause #90032@

                            # hier steht als letztes die Seitenanzahl z.B. (1/10) daraus ermitteln der Gesamtartikelmenge
                            # @http://wap.ebay.de/bid/viewitem.asp?emv_Id=200065581656&emvsid=2OF8Oh3Ntgkoe7QHyd@Samsung 8x Slim Brenner SN-S082D ~ahnlich Nec Pioneer LG@1/10@
                            # @http://wap.ebay.de/search/search_ext_res.asp?emvpi=2&emvquer=hmepowerseller&emvsidesc=0&emvstype=2&emvcat=&emvsid=2OF8Oh3Ntgkoe7QHyd@weiter@


                            # bei mehr als 6 Artikel Abfrage ob alle Artikel angezeigt werden sollen
                            # gilt nicht fuer Mitglieder Artikellisten hier wird leider keine Anzahl ausgegeben


                            if [ $suchtyp = "text" ] ; then

                              # Ermitteln der Artikelanzahl fuer die Artikelliste einer Text- oder Artikelsuche
                              anzahl=`sed '1!d' /tmp/ebaywap_mansearchresult.txt | sed -e 's#\(^.*\)@\(.*\)@\(.*$\)#\2#' -e 's/ Artikel gefunden.*//'`

                            else

                               # Ermitteln der Artikelanzahl fuer die Artikelliste eines Mitglieds
                               # @http://wap.ebay.de/bid/viewitem.asp?emv_Id=200065581656&emvsid=2OF8Oh3Ntgkoe7QHyd@Samsung 8x Slim Brenner SN-S082D ~ahnlich Nec Pioneer LG@1/10@
                               # @1/10@ -> 10 * 4 (es werden immer 4 Artikel pro Seite dargestellt)
                               # das stimmt jetzt zwar nicht ganz genau, da auf der letzten Seite auch weniger Artikel stehen koennen
                               # aber das vernachlaessige ich erstmal :-)

                               seitenanzahl=`sed -e '/@1\/[0-9].*@$/!d' -e 's#\(^.*\)@\(.*\)@\(.*\)@\(.*\)@\(.*$\)#\4#' -e 's/[0-9]\///' /tmp/ebaywap_mansearchresult.txt`
                               [ $seitenanzahl -gt 1 ] && anzahl=`expr $seitenanzahl \* 4`
                               # nach der Ermittlung die Seitenangabe loeschen, da sonst die Anzahl der Felder nicht stimmt
                               sed -i 's/@1\/[0-9].*@$/@/' /tmp/ebaywap_mansearchresult.txt

                            fi

                            if [ $runonce = "false" ] && [ $anzahl -gt 4 ] ; then

                                $msgbox title="$menutitel" msg="Es wurden $anzahl Artikel gefunden. Anzeigen?" default=2 select="Alle,nur die ersten 4,Abbruch"
                                case $? in
                                       1) # Anzahl der Seiten ermitteln fuer Fortschrittsanzeige
                                          # pro Seite werden 4 Artikel angezeigt daraus resultiert:
                                          gesamtseiten=`expr $anzahl / 4`
                                          # Falls Rest uebrig bleibt eine Seite dazu addieren
                                          [ `expr $anzahl % 4` -gt 0 ] && gesamtseiten=`expr $gesamtseiten + 1`
                                          ;;
                                       2) loop="false" ;;
                                       *) return 1 ;;
                                esac
                                runonce="true"
                            fi

                            # naechste Seitenr ermitteln, falls vorhanden
                            # ist fuer normale Suche und Mitgliedersuche unterschiedlich emvsi= bzw. emvpi=
                            # ja -> search_url anpassen und nochmal abfragen
                            # nein -> Schleife verlassen
                            seitenr=""
                            seitenr=`sed '/@weiter@/!d' /tmp/ebaywap_mansearchresult.txt | sed -e 's/^.*emv[sp]i=//' -e 's/&emvquer=.*$//g'`

                            if [ -z $seitenr ] || [ $loop = "false" ]  ; then

                              sed -i '/@weiter@/d' /tmp/ebaywap_mansearchresult.txt
                              break

                            else

                              # '@weiter@' Zeile entfernen und actsearch_url neu zusammensetzen
                              actsearch_url=`sed -e '/@weiter@/!d' -e 's/@weiter@//' -e 's/^@//' /tmp/ebaywap_mansearchresult.txt`
                              sed -i '/@weiter@/d' /tmp/ebaywap_mansearchresult.txt

                              # Fortschrittsmeldung ausgeben
                              $msgbox title="$menutitel" popup="Lade und bearbeite Seite: $seitenr von $gesamtseiten " refresh=0 timeout=2 &

                            fi

                fi

          done

          # 'Ergebnisse' und 'zurueck' Zeilen entfernen, Marker am Zeilenanfang entfernen
          sed -i '/@Ergebnisse:/d
                     /@zur~uck@/d
                          s/^@//g
                           s/"//g
                           s/#//g' /tmp/ebaywap_mansearchresult.txt

         # Ausgabedatei sieht jetzt so aus fuer normale Suche
         # zw. aktuellem Preis und Angebotsende
         # http://wap.ebay.de/bid/viewitem.asp?emv_id=200064881436&emvsid=F281v9D8J2066972h6@Fernbedienung f~ur die Dreambox 5600, 5620 und 500 S/C/T@15,51 EUR@5@06.01.2007 11:13@
         # http://wap.ebay.de/bid/viewitem.asp?emv_id=270074622391&emvsid=F281v9D8J2066972h6@Dreambox Tastatur , Keyboard , f~ur DM 500 , 7000 , 7020@19,60 EUR@7@06.01.2007 12:33@

         # und fuer Mitgliederabfrage
         # http://wap.ebay.de/bid/viewitem.asp?emv_Id=200066035483&emvsid=rOIrqyhmIXn0tFCc2W@160 GB HD Samsung HM160JC 2.5 8MB Cache 5400U # 29050@
         # http://wap.ebay.de/bid/viewitem.asp?emv_Id=200066035794&emvsid=rOIrqyhmIXn0tFCc2W@80 GB HD Samsung MP0804H 2.5 8MB Cache 5400U # 29042@

  }

#------------------- Artikelinfo ausgeben ------------------

artikelinfo () {

      artikel_url="$1"
      buttontext="${2:-zur~uck}"


      # Ebay Artikeldetails einlesen
      timeout
      wget -O /tmp/ebaywap.$$ "$artikel_url"
      kill $!

       # pruefen ob Artikel gefunden wurde vorhanden ist
      if [ `grep -c 'Bitte geben Sie eine g&#252;ltige Artikelnummer ein'  /tmp/ebaywap.$$` -gt 0 ] ; then

        $msgbox title='Achtung!' msg="~nEs wurden keine Artikelinformationen f~ur~n~s~nArtikelnummer:   ~Y$artikelnr~S~n~s~ngefunden!" timeout=10 ; return 1
      fi

      # Session ID ermitteln
      sid=`sed -e 's/^.*emvsid=//' -e 's/">Impressum<.*$//' -e 's/&amp.*$//g' /tmp/ebaywap.$$`

      # Artikeldaten ermitteln und als msgbox Textfile abspeichern
      formatartikel /tmp/ebaywap.$$ >/tmp/ebaywap_artikeldetail.txt

      # aufraeumen
      rm /tmp/ebaywap.$$

      if [ -s /tmp/ebaywap_artikeldetail.txt ] ; then

        # Artikelnummer ermitteln
        artikelnr=`sed -e '/Artikelnummer/!d' -e 's/Artikelnummer: ~T190//' /tmp/ebaywap_artikeldetail.txt`

        # Verkaeufer ermitteln
        verkaeufer=`sed -e '/Verk~aufer: ~T190/!d' -e 's/Verk~aufer: ~T190//' -e 's/([0-9].*)//' /tmp/ebaywap_artikeldetail.txt`

        # Bieter ermitteln
        bieter=`sed -e '/H~ochstbietender: ~T190/!d' -e 's/.*H~ochstbietender: ~T190//' -e 's/([0-9].*)//' /tmp/ebaywap_artikeldetail.txt`

        # pruefen ob Artikelnummer in artikelfile vorhanden ist
        # und ggfs. die Vorwarnzeit auslesen
        if [ -s $artikelliste ] ; then
          set `grep $artikelnr $artikelliste`
          vzeit=$2
        fi

        # Auktionsende ermitteln und umwandeln in busybox date -d Datumsformat
        # 14.01.2007 17:30:06 -> 2007.01.14-17:30:00
        endzeit=`sed -e '/~T350Endet:/!d' -e 's/^.*Endet: //' -e 's#\(^.*\)\.\(.*\)\.\(.*\) \(.*\):\(.*\):\(.*$\)#\3.\2.\1-\4:\5:\6#' /tmp/ebaywap_artikeldetail.txt`

        # Auktionsende in sec vom 01.01.70 ausrechnen
        # TZ auswerten klappt irgendwie nicht mit dem busybox date
        # date rechnet immer mit UTC , vielleicht bin ich auch zu bloed :-)
        # von 'endzeit_sec' in 'endzeit_utc_sec' geaendert - mod by rich

        endzeit_utc_sec=`date -d "$endzeit" +%s`

        TZ=`date +%Z`
        if [ $TZ = "CET" ]
        then
           #  UTC+1h (+ 3600) fuer MEZ
           #  UTC+2h (+ 7200) fuer MESZ
           #  Korrektur von rich
           endzeit_sec=`expr $endzeit_utc_sec + 3600`
        else
           # UTC+2h = MESZ
           endzeit_sec=`expr $endzeit_utc_sec + 7200`
        fi

        # Versand,Foto und Beschreibung-URL ermitteln
        aktversand_url=`echo $versand_url | sed -e "s:_ARTIKELNUMMER_:$artikelnr:" -e "s:_SID_:$sid:"`
        # schon mal im Hintergrund einlesen
        wget -q -O- "$aktversand_url" | formatversand >/tmp/ebaywap_artikelversand.txt &

        aktfoto_url=`echo $foto_url | sed -e "s:_ARTIKELNUMMER_:$artikelnr:" -e "s:_SID_:$sid:"`

        #echo "$aktfoto_url" >/tmp/ttt

        aktbeschreibung_url=`echo $beschreibung_url | sed -e "s:_ARTIKELNUMMER_:$artikelnr:" -e "s:_SID_:$sid:"`
        # das geht leider nicht weil wget nicht die komplette Seite einliest im Gegensatz zu tuxwetter
        # keine Ahnung warum.....
        #wget -q -O- "$aktbeschreibung_url"  >/tmp/ebaywap_artikelbesch.htm &
        #$tuxwetter "TXTHTML=Artikel_Beschreibung,$aktbeschreibung_url|Beschreibung|Hinweis: Diese Seite enth&#228;lt" &

        # Aktion ermitteln fuer Buttontext
        # Artikelnummer bereits gespeichert ->loeschen
        # Artikelnummer nicht gespeichert ->speichern
        if [ `grep -c $artikelnr $artikelliste 2>/dev/null` -eq 1 ] ; then
          action="l~oschen"
        else
          action="speichern"
        fi

        loop="true"
        while $loop ; do

           #  Korrektur von rich
           timer_no=""
           timer_al=""

           # Vorwarnzeit berechnen
           if [ `echo "$vzeit"  | grep -c '[0-9]'` -gt 0 ] ; then

             # Vorwarnzeit in Sekunden von der Endzeit abziehen
             vorwarnzeit_sec=`expr $endzeit_sec - $vzeit \* 60`

             # und wieder in lesbares Format wandeln
             vorwarnzeit=`date -d "1970.01.01-0:0:$vorwarnzeit_sec" +"%d.%m.%y %H:%M:%S"`

             # DBOX timerd Eintrag ; Dreambox crond mit crontab
             if [ $boxtype = "dbox" ] ; then

                 # Vorhandene Timer Nummer
                 timerinfo=`wget -q -Y off -O - "http://localhost/control/timer"`
                 if [ -n "$timerinfo" ] ; then
                   timer_no=`echo "$timerinfo" | sed -e '{/^[0-9]* 6 .* eBay '$artikelnr' /!d;s/^\([0-9]*\).*/\1/}' | sed -e '1!d'`
                   echo "&timer_no"
                   timer_al=`expr $timer_no + 1`
                   echo "&timer_al"
                 fi

             else

                 # Vorwarnzeit z.B. 13.01.07 18:22:47 umwandeln ins crontab Format

                 # crontab format
                 # +---------minute         00-59
                 # | +-------hour           00-23
                 # | | +-----day of month   00-31
                 # | | | +---month          00-12
                 # | | | | +-day of week    1-7 (7 is Sun)
                 # | | | | |
                 # * * * * * command
                 croneintrag=`date -d "1970.01.01-0:0:$vorwarnzeit_sec" +"%M %H %d %m"`

                 if [ ! -s $crontab ] ; then

                    echo "$croneintrag * $msgbox title='Achtung!' msg='Auktion f~ur Artikel: $artikelnr endet in $vzeit min.' timeout=30 " >$crontab

                 else

                    # falls vorhanden alten Eintrag loeschen
                    sed -i "/Artikel: $artikelnr /d" $crontab
                    echo "$croneintrag * $msgbox title='Achtung!' msg='Auktion f~ur Artikel: $artikelnr endet in $vzeit min.' timeout=30 " >>$crontab

                 fi
              fi

             # alten Eintrag loeschen
             sed -i '/Vorwarnung:/d' /tmp/ebaywap_artikeldetail.txt
             # neuen Eintrag einfuegen
             sed -i "s/Verk~aufer/~GVorwarnung: ~T190$vorwarnzeit~S\nVerk~aufer/" /tmp/ebaywap_artikeldetail.txt

           fi

           # leider hat die msgbox 1.52 (akt. Version auf der Dreambox) noch einen Bug bei absolute=1 und
           # wenn der default-Wert nicht der Anzahl der tatsaechlichen Buttons entspricht
           # msgbox <param error: default=8>
           # dehalb wird der Bieter Button immer angezeigt auch wenn die Auktion noch keinen Bieter hat.
           # Abfrage ob Bieter vorhanden erfolgt deshalb in der entsprechenden case Anweisung
           $msgbox title="Artikelinfo f~ur $artikelnr" size=26 order=2 default=8 absolute=1 select="Artikelnummer $action,Vorwarnzeit,Versandkosten,Artikel Beschreibung,Artikel Foto,Alle Auktionen Verk~aufer,Alle Auktionen Bieter,$buttontext" msg=/tmp/ebaywap_artikeldetail.txt

            case $? in

               0) # LAME Taste
                  return 1
                  ;;
               1) if [ $action = "speichern" ] ; then
                     echo $artikelnr >>$artikelliste
                     action="l~oschen"
                  else

                     sed -i "/$artikelnr/d" $artikelliste

                     # vorhandenen D-Box Timer loeschen; Dreambox crond loeschen
                     if [ $boxtype = "dbox" ]; then

                          if [ -n "$timer_no" ]; then
                            wget -q -Y off -O - "http://localhost/control/timer?action=remove&id=$timer_no" > /dev/null
                          fi

                          if [ -n "$timer_al" ]; then
                						wget -q -Y off -O - "http://localhost/control/timer?action=remove&id=$timer_al" > /dev/null
             							fi

                     else

                          sed -i "/Artikel: $artikelnr /d" $crontab

                     fi

                     sed -i '/Vorwarnung:/d' /tmp/ebaywap_artikeldetail.txt
                     vzeit=""
                     action="speichern"
                  fi
                  ;;

               2) if [ $boxtype = "dbox" ] ; then
                    dbox_timer
                  else
                    dreambox_cron
                  fi
                  ;;

               3) # Ebay Versanddetails anzeigen
                  if [ -s /tmp/ebaywap_artikelversand.txt ] ; then
                    $msgbox title="Versandinfo f~ur $artikelnr" size=28 select="Zur~uck" msg=/tmp/ebaywap_artikelversand.txt
                  else
                    $msgbox title="Achtung!" size=24 msg="Fehler bei der Ermittlung der Versandinfos!"
                  fi
                  ;;

               4) # Komplette Beschreibung anzeigen
                  $tuxwetter "TXTHTML=Artikel_Beschreibung,$aktbeschreibung_url|Beschreibung|Hinweis: Diese Seite enth&#228;lt"
                  ;;

               5) # Foto anzeigen
                  timeout
                  foto=`wget -q -O- "$aktfoto_url"  |\
                        sed  's/.*url=http/http/
                              s/\&amp;/\&/g
                              s/\" alt=\"Foto\".*$//'`
                  kill $!
                  # Foto anzeigen
                  $tuxwetter PICTURE=Artikel_Foto,"$foto"
                  ;;

               6) membersuche "$verkaeufer"
                  loop="false"
                  ;;

               7) if [ "$bieter" != "-" ] ; then
                   membersuche "$bieter"
                   loop="false"
                  fi
                  ;;

               8) # Weiter/Zurueck gedrueckt, Schleife verlassen
                  loop="false"
                  ;;
            esac

        done
      else

        $msgbox title="Achtung!"  msg="Fehler bei der Ermittlung der Artikelinfos!"

      fi

  }

#------------------- Formatierung fuer Artikelinfo und Versandinfo - danke rich :-)------------------

formatartikel () {


      sed '# Unterstriche wegsichern, und spaeter wiederherstellen
           # _ werden z.b. in Mitgliedsnamen verwendet
          s/_/BARABAS/g
          # Alle Tags durch Unterstriche ersetzen
          s/<[^>]*>/_/g
          # Hochkomma , Komma durch Leerzeichen Punkt ersetzen
          y/'\'',/ ./
          # Fuehrende Leerzeichen vor Unterstrich entfernen
          s/ *_/_/g
          # alles bis zu Kategorien loeschen und alles bis zum naechsten Unterstrich ausgeben (Artikelkurzinfo)
          s/.*Kategorien_*-*_*\([^_]*\)/~s\n~Y\1~S\n~s\n/
          # Verbleibenden Zeit ausgeben
          s/_.*Verbleibende Zeit:_*\([^_]*\)/~GVerbleibende Zeit: ~T190\1 ~T350/
          # Aktuelles Gebot falls normale Auktion
          s/_.*lles Gebot:_*\([^_]*\)/Aktuelles Gebot: \1~S\n/
          # Hoechstbietenden ausgeben
          s/_.*chstbietender:_*\([^_]*\)/H~ochstbietender: ~T190\1\n/
          # Artikelnummer ausgeben
          s/_.*Artikelnr.:_*\([^_]*\)/Artikelnummer: ~T190\1\n/
          # Zusatztitel falls vorhanden
          s/_.*Zusatztitel:_*\([^_]*\)/Zusatztitel: ~T190\1\n/
          # Menge ausgeben falls vorhanden
          s/_.*Menge:_*\([^_]*\)/Menge: ~T190\1 ~T350/
          # Zustand ausgeben
          s/_.*Artikelzustand:_*\([^_]*\)/Artikelzustand: \1\n/
          # Preis ausgeben falls SofortKauf Aktion
          s/_.*Preis:_*\([^_]*\)/Preis: ~T190\1\n/
          # Startpreis ausgeben falls normale Aktion
          s/_.*Startpreis:_*\([^_]*\)/Startpreis: ~T190\1\n/
          # Gebotsanzahl ausgeben
          s/_.*Gebotsanzahl:_*\([^_]*\)/Anzahl Gebote: ~T190\1\n/
          # Angebotsstart und ende
          s/_.*Start:_*\([^_]*\)/Start: ~T190\1 ~T350/
          s/_.*Endet:_*\([^_]*\)/Endet: \1\n/
          # Verkaeufer ausgeben
          s/_.*Verk\&#228;ufer:_*\([^_]*\)/Verk~aufer: ~T190\1\n/
          # Ort und Land
          s/_.*Ort:_*\([^_]*\)/Ort: ~T190\1 ~T350/
          s/_.*Land:_*\([^_]*\)/Land: \1\n~s\n/
          # Restliche Zeile loeschen
          s/_---*.*$//
          # Sonderzeichen umwandeln
          s/&#246;/~o/g;s/&#176;//g;s/&#177;/ /g;s/&#228;/~a/g;s/&#252;/~u/g;s/&#214;/~O/g;s/&#196;/~A/g;s/&#220;/~U/g;s/&#8364;/Euro/g;s/&#160;/ /g;s/&#223;/~z/g;s/&#167;//g;s/&#62;/>/g;s/&#60;/</g;s//~z/g' $1 |\

      sed '# Untersriche wieder herstellen
           s/BARABAS/_/g'

 }

formatversand () {

	    sed '# Unterstriche wegsichern
          s/_/BARABAS/g
          # Alle Tags durch Unterstriche ersetzen
          s/<[^>]*>/_/g
          # Hochkomma , Komma durch Leerzeichen Punkt ersetzen
          y/'\'',/ ./
          # Fuehrende Leerzeichen vor Unterstrich entfernen
          s/ *_/_/g
          # alles bis zu Kategorien loeschen und alles bis zum naechsten Unterstrich ausgeben (Artikelkurzinfo)
          s/.*Kategorien_*-*_*\([^_]*\)/~s\n~Y\1~S\n~s\n/
          # Zahlungsmethoden ausgeben
          s/_.*Akzeptierte Zahlungsmethoden:_*\([^_]*\)/\1\n/
          # Versandkosten
          s/_.*Versandkosten:_*\([^_]*\)/~s\n~GVersandkosten: ~t\1 Euro~S\n~s\n/
          # Versand nach
          s/_.*Versand nach:_*\([^_]*\)/Versand nach: ~t\1\n/
          # Versand-Infos
          s/_.*Versand-Information:_*\([^_]*\)/\1\n/
          # Versicherungsinfo ausgeben falls vorhanden
          s/_.*Versicherung:_*\([^_]*\)/\1\n~s\n/
          # restliche Zeile loeschen
          s/_---*.*$//
          # Sonderzeichen umwandeln
          s/&#246;/~o/g;s/&#176;//g;s/&#177;/ /g;s/&#228;/~a/g;s/&#252;/~u/g;s/&#214;/~O/g;s/&#196;/~A/g;s/&#220;/~U/g;s/&#8364;/Euro/g;s/&#160;/ /g;s/&#223;/~z/g;s/&#167;//g;s/&#62;/>/g;s/&#60;/</g;s//~z/g' |\

     sed '# Untersriche wieder herstellen
          s/BARABAS/_/g'


 }

 # --------------------- Dbox timer --------------------------------------

 dbox_timer () {

      # Vorwarnzeit eingeben/aendern - mod by rich
      # Pruefen ob Auktion bereits beendet
      if [ `grep -c '~T190Auktion beendet' /tmp/ebaywap_artikeldetail.txt` -eq 0 ]; then

         # Vorwarnzeit eingeben
         vzeit=`$input l='##' t='Vorwarnzeit eingeben in min.' k=0`
         if [ `echo "$vzeit" | grep -c '[0-9]'` -gt 0 ]; then

            # Timer in sec vom 01.01.70 ausrechnen, 'endzeit_utc_sec' - mod by rich
            vorwarn_utc_sec=`expr $endzeit_utc_sec - $vzeit \* 60`

            # Text fuer Timer - mod by rich
            timertext=`echo "eBay%20$artikelnr%20-%20in%20$vzeit%20min"`

            # Timer setzen - mod by rich
            if [ -n "$timer_no" ] ; then
               # Timer aendern
               wget -q -Y off -O - "http://localhost/control/timer?action=modify&id=$timer_no&alarm=$vorwarn_utc_sec&type=6&rs=0&msg=$timertext" > /dev/null
            else
               # Timer neu
               wget -q -Y off -O - "http://localhost/control/timer?action=new&alarm=$vorwarn_utc_sec&type=6&rs=0&msg=$timertext" > /dev/null
            fi

            # Soundtimer setzen - mod by DrStoned
            if [ -n "$timer_al" ] ; then
               # Timer aendern
							 wget -q -Y off -O - "http://localhost/control/timer?action=modify&id=$timer_al&alarm=$vorwarn_utc_sec&type=8&rs=0&PluginName=Ebay-Alarm" > /dev/null

            else
               # Timer neu
							 wget -q -Y off -O - "http://localhost/control/timer?action=new&alarm=$vorwarn_utc_sec&type=8&rs=0&PluginName=Ebay-Alarm" > /dev/null
            fi


            # Artikelnummer inkl. Vorwarnzeit abspeichern
            [ ! -s $artikelliste ] && touch $artikelliste
            if [ `grep -c "$artikelnr" $artikelliste` -eq 0 ]; then

              echo "$artikelnr $vzeit" >>$artikelliste

            else

               sed -i "s/$artikelnr.*$/$artikelnr $vzeit/" $artikelliste

            fi

            action="l~oschen"

          else

             # vorhandenen Timer loeschen - mod by rich
             if [ -n "$timer_no" ]; then
                wget -q -Y off -O - "http://localhost/control/timer?action=remove&id=$timer_no" > /dev/null
             fi

             if [ -n "$timer_al" ]; then
                wget -q -Y off -O - "http://localhost/control/timer?action=remove&id=$timer_al" > /dev/null
             fi

             # Vorwarnzeit aus Artikelnummernliste loeschen
             sed -i "s/$artikelnr.*$/$artikelnr/" $artikelliste
             # Vorwarnung Eintrag aus Artikelinfo loeschen
             sed -i '/Vorwarnung:/d' /tmp/ebaywap_artikeldetail.txt

          fi

       else
          # bei vorhandenen Timer - loeschen
          if [ -n "$timer_no" ]; then
            wget -q -Y off -O - "http://localhost/control/timer?action=remove&id=$timer_no" > /dev/null
          fi

          if [ -n "$timer_al" ]; then
            wget -q -Y off -O - "http://localhost/control/timer?action=remove&id=$timer_al" > /dev/null
          fi

          $msgbox title='Achtung!' msg="Die Auktion ist bereits beendet!" timeout=5

       fi

   }

 # -------------------- Dreambox Crontab ----------------------------------

 dreambox_cron () {

      # Vorwarnzeit eingeben/aendern
      if check_cron ; then

          # Pruefen ob Auktion bereits beendet
          if [ `grep -c '~T190Auktion beendet' /tmp/ebaywap_artikeldetail.txt` -eq 0 ] ; then

              # Vorwarnzeit eingeben
              vzeit=`$input l='##' t='Vorwarnzeit eingeben in min.' k=0`

              if [ `echo "$vzeit" | grep -c '[0-9]'` -gt 0 ] ; then

                  # Artikelnummer inkl. Vorwarnzeit abspeichern
                  [ ! -s $artikelliste ] && touch $artikelliste
                  if [ `grep -c "$artikelnr" $artikelliste` -eq 0 ] ; then
                    echo "$artikelnr $vzeit" >>$artikelliste
                  else
                     sed -i "s/$artikelnr.*$/$artikelnr $vzeit/" $artikelliste
                  fi

                  action="l~oschen"

              else

                 # Vorwarnzeit aus Artikelnummernliste loeschen
                 sed -i "s/$artikelnr.*$/$artikelnr/" $artikelliste
                 # Vrowarnung Eintrag aus Artikelinfo loeschen
                 sed -i '/Vorwarnung:/d' /tmp/ebaywap_artikeldetail.txt
                 # Eintrag aus crontab loeschen
                 sed -i "/Artikel: $artikelnr /d" $crontab

              fi

          else

             $msgbox title='Achtung!' msg="Die Auktion ist bereits beendet!" timeout=5

          fi
      fi
    }

 # ------------------- flexmenu konfig zusammenbauen ----------------------

flexkonf () {



     case $1 in
       "kopf") # Titeltext
               titel="$2"

               echo "FONT=/share/fonts/micron_bold.ttf
                    FONTSIZE=18
                    LINESPP=10
                    MENU=$titel" >/tmp/ebaywap_mansearchresult.inc
               ;;
       "main") # Gefundene Suchergebnisse fuers flexmenu aufarbeiten

               if [ $2 = "text" ] ; then

                 sed "s#\(.*\)@\(.*\)@\(.*\)@\(.*\)@\(.*$\)#ACTION=\&\2,$0 artikelinfo '\1' \"zur~uck\",Bitte warten, lade Artikeldaten.\nCOMMENT=*\3 * \4 * \5#" /tmp/ebaywap_mansearchresult.txt >>/tmp/ebaywap_mansearchresult.inc

               else

                 # erstmal die URL als COMMENT anhaengen und dann im 2ten Step die Artikelnummer ermitteln
                 # das geht sicher einfacher aber mir fehlen da momentan die geistigen Mittel...:-)
                 sed "s#\(^.*\)@\(.*\)@\(.*$\)#ACTION=\&\2,$0 artikelinfo '\1' \"zur~uck\",Bitte warten, lade Artikeldaten.\nCOMMENT=*Artikelnr.:'\1'#" /tmp/ebaywap_mansearchresult.txt >>/tmp/ebaywap_mansearchresult.inc
                 # Artikelnummer ermitteln aus URL ermitteln und als COMMENT mit ausgeben
                 sed -ie 's/Artikelnr.:.*Id=//' -ie '/^COMMENT/s/&emvsid=.*$//' /tmp/ebaywap_mansearchresult.inc

               fi
               ;;
       "ende") echo "ENDMENU" >>/tmp/ebaywap_mansearchresult.inc
               ;;
     esac
  }

#---------------------------------------------------------------------
# Falls Auktionen berwacht werden sollen prfen und melden wenn crond nicht luft.
# ACHTUNG! Auf der 7000/500er ist das ein kleines aber feines Script von
# Georges und kein echter cron Deamon!
#---------------------------------------------------------------------
check_cron () {

    if [ `ps | grep -c crond` -lt 2  ]
    then
      $msgbox title="Achtung!" msg="crond Prozess l~auft nicht!~nKeine ~Uberwachung der Auktionen m~oglich!" timeout=10
      return 1
    else
      return 0
    fi
  }

#---------------------------------- Main ------------------------------

case "$1" in

               makemainmenu) makemainmenu ;;
                  neuesuche) neuesuche ;;
              speichersuche) speichersuche ;;
                loeschsuche) loeschsuche ;;
                  editsuche) editsuche ;;
                letztesuche) letztesuche "$2" ;;
                artikelinfo) artikelinfo "$2" ;;
              neueartikelnr) neueartikelnr ;;
              leseartikelnr) leseartikelnr ;;
            loeschartikelnr) loeschartikelnr ;;
                membersuche) membersuche ;;
        speichermembersuche) speichermembersuche ;;
               loeschmember) loeschmember ;;
                 editmember) editmember ;;
     alle_artikelnranzeigen) alle_artikelnranzeigen ;;
     meine_ebayliste_gebote) meine_ebayliste_gebote ;;


esac
